// ADP utilities
// Copyright (c) GTek Technologies Ltd.

var g_oAdp; // ADPBrowser instance (should be set by the InitADP function)

function closeAdp() { // closes ADP
   if (g_oAdp.Vars("ReturnCodeFixed") != "TRUE")
      g_oAdp.ReturnCode = -1;
   else
      g_oAdp.ReturnCode = 0;

   g_oAdp.close();
}  

// constructs ADP plugin object for further reference through getObj() method
function ADPPlugin(sContent) {
   var o, sName = sContent.replace(/^Name=(\w+).*/i, "$1");
  
   function create() {
      g_oAdp.RunMeta("SB_CreateObject", sContent);
      o = g_oAdp.Objects(sName);
      return o;
   }  

   function create() {
      try {
         g_oAdp.RunMeta("SB_CreateObject", sContent);
         o = g_oAdp.Objects(sName);
      } catch(e) {
         return false;
      }

      if (o != null)
         return o;
      else
         return false;
   } 

   this.getObj = function() { // creates real object on first call
      return o || create();
   };
}


function adjustGUI() { // makes GUI arrangements at run-time
   document.body.style.overflow = "hidden";
  
   function cancelEvent() {
      event.returnValue = false;
     return false; 
   }  
  
   document.onselectstart = cancelEvent; // disables text selection
   document.onkeydown = function() {     // disables open new explorer window (CTRL + N)
      if (event.ctrlKey && event.keyCode == 0x4E) {
         return cancelEvent(); 
      }
   };
   
   g_oAdp.RunMeta("SB_Position", posAdpWin());
}  

function posAdpWin() { // creates ADP win by current user's screen settings
   adpX = screen.width - 234;
   adpY = screen.height - 290;
   return "x="+adpX+",y="+adpY+",Width=234,Height=290,DesktopSize=1";
}  

function hideChildren(oElem) { // hides children of an element
   var o = oElem.children;

   for (var i=0; i < o.length; ++i) {
      o(i).style.display = "none";
   }
}  

function showScreen(oElem, oBtns) { // shows virtual screen (message and buttons)
   hideChildren(document.body);
   
   if (oElem.className == "Screen")
      oElem.innerHTML = g_hdrStr + oElem.innerHTML; // creates ADP Header

   oElem.style.display = "";
  
   for (var sName in oBtns) { // sets buttons
      oElem.all[sName].attachEvent("onclick", oBtns[sName]);
   }  
}